-----------------------------------------------------------
--             FuBar PlugIn for InstanceTime              -
-----------------------------------------------------------

-- variables
local L = AceLibrary("AceLocale-2.2"):new("InstanceTimeFu");
local tablet = AceLibrary("Tablet-2.0");
InstanceTimeFu = AceLibrary("AceAddon-2.0"):new("FuBarPlugin-2.0", "AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0");
InstanceTimeFu.title = "FuBar - InstanceTime";
InstanceTimeFu.name = "InstanceTime";
InstanceTimeFu.hasIcon = "Interface\\AddOns\\FuBar_InstanceTimeFu\\icon_off.tga";
InstanceTimeFu.category = "Raid";
InstanceTimeFu.author = "Dhana @ Alleria";
InstanceTimeFu_DisplayXP = false;
InstanceTimeFu_DisplayREP = false;
InstanceTimeFu_DisplayGOLD = false;
InstanceTimeFu_DisplayGOLDShort = false;


if(IsAddOnLoaded("FuBar")) and (IsAddOnLoaded("FreierGeist_InstanceTime")) then
	DEFAULT_CHAT_FRAME:AddMessage("|cffffd200FuBar [InstanceTime] "..INSTANCETIME_INFO_TEXT.."|r|ccceebbbb loaded|r");
else
	return;
end
		

local options = {
	type = 'group',
	args = {
		announce = {
			type = "group",
			name = L["MENU_MAIN"],
			desc = L["DESC_MAIN"],
			args = {
				option_1 = {
					type = "toggle",
					name = L["MENU_TIMER"],
					desc = L["DESC_TIMER"],
					get = "IsValue",
					set = "ToggleValue",
					order = 1;
				},
				option_2 = {
					type = "toggle",
					name = L["MENU_XP"],
					desc = L["DESC_XP"],
					get = "IsValueXP",
					set = "ToggleValueXP",
					order = 2;
				},
				option_3 = {
					type = "toggle",
					name = L["MENU_REP"],
					desc = L["DESC_REP"],
					get = "IsValueRep",
					set = "ToggleValueRep",
					order = 3;
				},
				option_4 = {
					type = 'toggle',
					name = L["MENU_CREATE_ENTRY"],
					desc = L["DESC_CREATE_ENTRY"],
					get = "IsValueEntry",
					set = "ToggleValueEntry",
					order = 4;
				},
				option_5 = {
					type = 'execute',
					name = L["MENU_OPTIONS"],
					desc = L["DESC_OPTIONS"],
					func = "Options",
					order = 5;
				},
				option_6 = {
					type = 'execute',
					name = L["MENU_HELP"],
					desc = L["DESC_HELP"],
					func = "Help",
					order = 6;
				},
				option_7 = {
					type = 'execute',
					name = L["MENU_DELETE"],
					desc = L["DESC_DELETE"],
					func = "DeleteList",
					order = 7;
				},
				option_8 = {
					type = 'toggle',
					name = L["MENU_DISPLAY_FUBAR_XP"],
					desc = L["DESC_DISPLAY_FUBAR_XP"],
					get = "IsValueFuBarXP",
					set = "ToggleFuBarXP",
					order = 8;
				},
				option_9 = {
					type = 'toggle',
					name = L["MENU_DISPLAY_FUBAR_REP"],
					desc = L["DESC_DISPLAY_FUBAR_REP"],
					get = "IsValueFuBarREP",
					set = "ToggleFuBarREP",
					order = 9;
				},
				option_10 = {
					type = 'toggle',
					name = L["MENU_DISPLAY_FUBAR_GOLD"],
					desc = L["DESC_DISPLAY_FUBAR_GOLD"],
					get = "IsValueFuBarGOLD",
					set = "ToggleFuBarGOLD",
					order = 10;
				},
				option_11 = {
					type = 'toggle',
					name = L["MENU_DISPLAY_FUBAR_GOLD_SHORT"],
					desc = L["DESC_DISPLAY_FUBAR_GOLD_SHORT"],
					get = "IsValueFuBarGOLDShort",
					set = "ToggleFuBarGOLDShort",
					order = 10;
				},
			},
		},
	}
}
InstanceTimeFu:RegisterChatCommand(L["COMMANDS"], options);
InstanceTimeFu.OnMenuRequest = options;
InstanceTimeFu.hasNoColor = true;
InstanceTimeFu:RegisterDB("InstanceTimeFuDB")


function InstanceTimeFu:IsValue()
	if(FreierGeist_IT_GlobalVisibility) then
		self.value = true;
	else
		self.value = false;
	end
	return self.value;
end


function InstanceTimeFu:IsValueXP()
	if(FreierGeist_IT_XPVisibility) then
		self.value = true;
	else
		self.value = false;
	end
	return self.value;
end


function InstanceTimeFu:IsValueRep()
	if(FreierGeist_IT_RepVisibility) then
		self.value = true;
	else
		self.value = false;
	end
	return self.value;
end


function InstanceTimeFu:IsValueEntry()
	if(FreierGeist_IT_GetCreateNewEntry()) then
		self.value = true;
	else
		self.value = false;
	end
	return self.value;
end


function InstanceTimeFu:IsValueFuBarXP()
	if(InstanceTimeFu_DisplayXP) then
		self.value = true;
	else
		self.value = false;
	end
	return self.value;
end


function InstanceTimeFu:IsValueFuBarREP()
	if(InstanceTimeFu_DisplayREP) then
		self.value = true;
	else
		self.value = false;
	end
	return self.value;
end


function InstanceTimeFu:IsValueFuBarGOLD()
	if(InstanceTimeFu_DisplayGOLD) then
		self.value = true;
	else
		self.value = false;
	end
	return self.value;
end


function InstanceTimeFu:IsValueFuBarGOLDShort()
	if(InstanceTimeFu_DisplayGOLDShort) then
		self.value = true;
	else
		self.value = false;
	end
	return self.value;
end


function InstanceTimeFu:ToggleValue()
	FreierGeist_IT_ShowTimer();
end


function InstanceTimeFu:ToggleValueXP()
	FreierGeist_IT_ShowXP();
end


function InstanceTimeFu:ToggleValueRep()
	FreierGeist_IT_ShowRep();
end


function InstanceTimeFu:ToggleValueEntry()
	FreierGeist_IT_SetCreateNewEntry();
end


function InstanceTimeFu:Options()
	FreierGeist_IT_ShowOptions();
end


function InstanceTimeFu:Help()
	FreierGeist_IT_Help();
end


function InstanceTimeFu:DeleteList()
	StaticPopup_Show("DELETE_LIST");
end


function InstanceTimeFu:ToggleFuBarXP()
	if (InstanceTimeFu_DisplayXP) then
		InstanceTimeFu_DisplayXP = false;
	else
		InstanceTimeFu_DisplayXP = true;
	end
	self:OnTextUpdate();
end


function InstanceTimeFu:ToggleFuBarREP()
	if (InstanceTimeFu_DisplayREP) then
		InstanceTimeFu_DisplayREP = false;
	else
		InstanceTimeFu_DisplayREP = true;
	end
	self:OnTextUpdate();
end


function InstanceTimeFu:ToggleFuBarGOLD()
	if (InstanceTimeFu_DisplayGOLD) then
		InstanceTimeFu_DisplayGOLD = false;
	else
		InstanceTimeFu_DisplayGOLD = true;
	end
	self:OnTextUpdate();
end


function InstanceTimeFu:ToggleFuBarGOLDShort()
	if (InstanceTimeFu_DisplayGOLDShort) then
		InstanceTimeFu_DisplayGOLDShort = false;
	else
		InstanceTimeFu_DisplayGOLDShort = true;
	end
	self:OnTextUpdate();
end


function InstanceTimeFu:OnTextUpdate()	
	if self:IsIconShown() then
		-- set button colour
		if(FreierGeist_IT_GetStartTime() == 0) then
			InstanceTimeFu:SetIcon("Interface\\AddOns\\FuBar_InstanceTimeFu\\icon_off.tga");
		else
			InstanceTimeFu:SetIcon("Interface\\AddOns\\FuBar_InstanceTimeFu\\icon_on.tga");
		end
	else
		self:HideIcon();
	end
	

	
	if self:IsTextShown() then
		local mytext = "";
		if(FreierGeist_IT_GetStartTime() > 0) then
			-- set time
			if(InstanceTimeFrameText:GetText() ~= nil) then
				mytext = mytext..InstanceTimeFrameText:GetText();
			end
		else
			-- set text 'InstanceTime'
			mytext = mytext..InstanceTimeFrameText:GetText();
		end
		
		if(InstanceTimeFu_DisplayXP or InstanceTimeFu_DisplayREP or InstanceTimeFu_DisplayGOLD or InstanceTimeFu_DisplayGOLDShort) then
			mytext = mytext.." -";
		end
		
		if (InstanceTimeFu_DisplayXP) then
			mytext = mytext.." |cccffffff"..InstanceTime_TimerFrameXPTextXPData:GetText().."|r "..InstanceTime_TimerFrameXPTextXP:GetText();
			mytext = string.gsub(mytext, ":", " ");
		end
			
		if (InstanceTimeFu_DisplayREP) then
			mytext = mytext.." |cccffffff"..InstanceTime_TimerFrameRepTextReputation1Data:GetText().."|r "..InstanceTime_TimerFrameRepTextReputation1:GetText();
			mytext = string.gsub(mytext, ":", " ");
		end
			
		if (InstanceTimeFu_DisplayGOLD) then
			mytext = mytext.." "..InstanceTime_ListFrameTextMoney:GetText();
		end
	
		if (InstanceTimeFu_DisplayGOLDShort) then
			tmptext = InstanceTime_ListFrameTextMoney:GetText();
			tmptext_g = string.gsub(tmptext, INSTANCETIME_MAIN_MONEY_GOLD, INSTANCETIME_MAIN_MONEY_GOLD_SHORT);
			tmptext_s = string.gsub(tmptext_g, INSTANCETIME_MAIN_MONEY_SILVER, INSTANCETIME_MAIN_MONEY_SILVER_SHORT);
			tmptext_c = string.gsub(tmptext_s, INSTANCETIME_MAIN_MONEY_COPPER, INSTANCETIME_MAIN_MONEY_COPPER_SHORT);
			mytext = mytext.." "..tmptext_c;
		end
		
		mytext = string.gsub(mytext, "  ", " ");
		mytext = string.gsub(mytext, "  ", " ");
		
		if(mytext ~= nil) then
			self:SetText(mytext);
		end
	end
	
	
end


function InstanceTimeFu:OnTooltipUpdate()
	local tmpTooltipText = "";
	
	
	if (string.match(FreierGeist_IT_DataOutput[2], "%(%)") ~= nil) then
		tmpTooltipText = tmpTooltipText..INSTANCETIME_TOOLTIP_FUBAR;
		tmpTooltipText = tmpTooltipText.."\n\n"..INSTANCETIME_TOOLTIP_BAR_2;
	else
		tmpTooltipText = tmpTooltipText.."\n"..FreierGeist_IT_DataOutput[1].."\n"..FreierGeist_IT_DataOutput[2];
		if(not FreierGeist_IT_XPOutput) then
			FreierGeist_IT_DataOutput[3] = "";
		else
			tmpTooltipText = tmpTooltipText.."\n"..FreierGeist_IT_DataOutput[3];
		end
		if(not FreierGeist_IT_ReputationOutput) then
			FreierGeist_IT_DataOutput[4] = "";
			FreierGeist_IT_DataOutput[5] = "";
			FreierGeist_IT_DataOutput[6] = "";
		else
			tmpTooltipText = tmpTooltipText.."\n"..FreierGeist_IT_DataOutput[4];
			if(FreierGeist_IT_DataOutput[5] ~= "") then
				tmpTooltipText = tmpTooltipText.."\n"..FreierGeist_IT_DataOutput[5];
			end
			if(FreierGeist_IT_DataOutput[6] ~= "") then
				tmpTooltipText = tmpTooltipText.."\n"..FreierGeist_IT_DataOutput[6];
			end
		end
		if(not FreierGeist_IT_MoneyOutput) then
			FreierGeist_IT_DataOutput[7] = "";
		else
			tmpTooltipText = tmpTooltipText.."\n"..FreierGeist_IT_DataOutput[7];
		end
	end
	
	if (tmpTooltipText ~= "") then
		local cat = tablet:AddCategory(
			'text', "",
			'columns', 2
		)
	
		cat:AddLine(
			'text', tmpTooltipText,
			'text2', ""
		)
	end
end


function InstanceTimeFu:OnClick()
	if(IsShiftKeyDown()) then
		FreierGeist_IT_Help();
	elseif(IsControlKeyDown()) then
		if(FreierGeist_IT_GetStartTime() == 0) then
			FreierGeist_IT_Start();
		else
			FreierGeist_IT_Stop();
		end
		InstanceTimeFu:Update();
	else
		FreierGeist_IT_ShowList();
	end
end


